'''
Created on 4 Feb 2011

@author: swilshin
'''

import numpy as np

def nonNaNBlocksNormalForm(d):
    nnb=nonNaNBlocks(d)
    if nnb==[]:
        return(nnb)
    else:
        return([[i[0],i[0]+i[1]] for i in nnb])

def nonNaNBlocks(d):
    md=np.array(d)
    nonNaNRegions=list()
    inNonNaNRegion=False
    for i in range(md.shape[0]):
        if not inNonNaNRegion:
            if not np.isnan(np.sum(md[i])):
                inNonNaNRegion=True
                nonNaNRegions.append([i,1])
        else:
            if not np.isnan(np.sum(md[i])):
                nonNaNRegions[-1][1]+=1
            else:
                inNonNaNRegion=False
    return(nonNaNRegions)

def largestNonNaNBlock(d):
    md=np.array(d)
    nonNaNRegions=nonNaNBlocks(md)
    nonNaNRegions=sorted(nonNaNRegions, key=lambda region: region[1],reverse=True)
    if len(nonNaNRegions)==0:
        return(d[0:0]) # if length zero return something of same type of length zero
    else:
        return(d[nonNaNRegions[0][0]:(nonNaNRegions[0][0]+nonNaNRegions[0][1])])

def rmNaN(l):
    return [e for e in l if not np.isnan(e)]