'''
Created on 4 Feb 2011

@author: swilshin
'''

import numpy as np

def expandFlatRegion(d,maxvar,i0,i1,step):
    v=np.var(d[i0:i1])
    ov=None
    while not ov==v:
        if i0>step:
            v0=np.var(d[(i0-step):i1])
        else:
            v0=v
        if i1<(len(d)-step):
            v1=np.var(d[i0:(i1+step)])
        else:
            v1=v
        if v0<v1 and v0<maxvar and i0>step:
            i0-=step
            ov=v
            v=v0
        else:
            if v1<maxvar and i1<(len(d)-step):
                i1+=step
                ov=v
                v=v1
            else:
                ov=v
    return((i0,i1))
    

def findFlatRegions(d,minl,maxVar,step):
    fr=[]
    step=int(step)
    i0=0
    i1=int(minl)
    while i1<len(d):
        v=np.var(d[i0:i1])
        if v>maxVar:
            i0+=step
            i1+=step
        else:
            fr.append(expandFlatRegion(d,maxVar,i0,i1,step))
            i0=fr[-1][1]+step
            i1=i0+minl
    return(fr)
